%% EE360D - Lecture 1 by David S
%% Section 1: Basics
% A) Matrices
clc
clearvars

n = -2:2;

y = [-2 0 1 3 2];

figure(1)
stem(n,y,'-g','filled','linewidth',3)
title('Plotting y over n')
xlabel('n')
ylabel('y')
prettyGraph

%% Exercise 1a
clearvars
clc
n = -10:25;
delta =[zeros(1,abs(n(1))) 1 zeros(1,abs(n(end)))]
unitstepLOL = [zeros(1,abs(n(1))) 1 ones(1,abs(n(end)))]


figure(2)
stem(n,delta,'-y','filled','linewidth',3)
title('Plotting Ex1a')
xlabel('n')
ylabel('unitstep(n)')
prettyGraph


figure(420)
stem(n,unitstepLOL,'-b','filled','linewidth',3)
title('Plotting Ex1a')
xlabel('n')
ylabel('delta(n)')
prettyGraph
%% Exercise 2a - Append Signals
A = [0 1 2 1];
B = [0 -1 -2 -1];

C = [A B];


figure(3)
stem(A,'-r','filled','linewidth',3)
title('A')

figure(4)
stem(B,'-m','filled','linewidth',3)
title('B')

figure(5)
stem(C,'-k','filled','linewidth',3)
title('C')
%% Function
function prettyGraph
grid on
ax = gca;
ax.FontSize = 12;
ax.LineWidth = 3;
set(gcf,'color','w');
end

