%% EE360D lecture 10

%% Ex 3a - DFI

clear variables
r = 0.9;
w0 = pi/7;
b1 = r.*sin(w0);
a1 = -2.*r.*cos(w0);
a2 = r.^(2);

prelength = 2;
endlength = 50;
n = -prelength:endlength;
unitstep = [zeros(1,abs(n(1))), 1 , ones(1,abs(n(end)))];
x = [zeros(1,abs(n(1))), 0 , zeros(1,abs(n(end)))];
y1a = [-r.^(-2).*sin(2.*w0), -r.^(-1).*sin(w0), zeros(1,1+abs(n(end)))];
c = [zeros(1,abs(n(1))), zeros(1,1+abs(n(end)))];

% Direct form block
for i = abs(n(1)) + 1 : n(end) + abs(n(1)) +1
    c(1,i) = 0;%b1.*x(1,i-1);
    y1a(1,i) = c(1,i) - a1.*y1a(1,i-1) - a2.*y1a(1,i-2);
end


% Impulse response of above
hAbove = r.^(n).*sin(w0.*n).*unitstep;

figure(4)
stem(n,y1a.*unitstep)
title('DFI Impulse')
xlabel('n')


figure(5)
stem(n,hAbove)
title('Quiz 6 ZIR')
xlabel('n')

%% Exercise 5

n = -prelength:endlength;
unitstep = [zeros(1,abs(n(1))), 1 , ones(1,abs(n(end)))];

%%
xDFI = x; % play variable!
prelength = length(h);
endlength = 50;
h = 1;
N = length(h);
unitstep = [zeros(1,N), 1 , zeros(1,abs(n(end)))];

x = [zeros(1,N), 1 , ones(1,abs(n(end)))];
Y = [zeros(1,N), 0 , zeros(1,abs(n(end)))]; % Setting up memory
x = unitstep
xDFI = x;
for i = abs(n(1))+1:abs(n(end))+abs(n(1))+1
    Y(1,i) = h*xDFI(1,N:-1:1).';
    xDFI = circshift(xDFI,-1);
end
    

figure(222)
stem(Y)


%% convvv
yheh = conv(h,x) 

figure(69)
stem(yheh) % n
% fix time or else minus 1 point lmao