%% EE360D lecture 9
prec = 0.1;
t = 0:prec:10
t1 = 10;
t2 = 20;
t3 = 30;

hResponse = [ones(1,t2),1,zeros(1,length(t)-1-t2)];
x = [t(1:t1),1,zeros(1,length(t)-1-t1)];

u0 = [zeros(1,0),1,ones(1,length(t)-1)];
u1 = [zeros(1,t1),1,ones(1,length(t)-1-t1)];
u2 = [zeros(1,t2),1,ones(1,length(t)-1-t2)];
u3 = [zeros(1,t3),1,ones(1,length(t)-1-t3)];
y0 = (1-t)


y  = +((t.^2)/2).*u0; %%  
y2 = -(((t-2).^2)/2).*u2; %%...
y3 = -(((t.^2)/2)-(1/2)).*u1;
y4 = ((((t-2).^2)/2) - (1/2)).*u3;
yT = y+y2+y3+y4;
figure(66)
plot(t,yT)

%%

%% Ex 3a - DFI

clear variables
r = 0.9;
w0 = pi/7;
b1 = r.*sin(w0);
a1 = -2.*r.*cos(w0);
a2 = r.^(2);

prelength = 2;
endlength = 50;
n = -prelength:endlength;

x = [zeros(1,abs(n(1))), 0 , zeros(1,abs(n(end)))];
y1a = [-r.^(-2).*sin(2.*w0), -r^(-1)*sin(w0), zeros(1,1+abs(n(end)))];
c = [zeros(1,abs(n(1))), zeros(1,1+abs(n(end)))];

for i = abs(n(1)) + 1 : n(end) + abs(n(1)) +1
    c(1,i) = b1.*x(1,i-1);
    y1(1,i) = c(1,i) - a1.*y1a(1,i-1) - a2.*y1a(1,i-2);
end

figure(4)
stem(n,y1a)
title('DFI Impulse')
xlabel('n')



%% Q5 question 2
clear variables
n = 0:14;
h = [1,1,1,1,1];
x = [zeros(1,length(h)-1),0,1,2,3,4, zeros(1,n(end)-4)];
xFlip = fliplr(x);
for i = abs(n(1))+1:abs(n(end))+abs(n(1))+1
    Y(1,i) = h*xFlip(1,end:-1:end-length(h)+1).';
    xFlip = circshift(xFlip,1);
end

figure(234)
stem(n,Y)
%% 
x1 = [1 3 3 1]; % x^3+3x^2+3x^1+1x^0
x2 = [1 2 1]; % 1x^2+2x^1+1x^0

solutionlmao = conv(x1,x2)


