%% EE360 Computer Assignment 2 by David S.
%% Exercise 1
% Draw block diagrams
%% Exercise 1a
% Presenting DFI
imgHaha = imread('EE360CompHW2_Ex1a.png');
figure(100)
imshow(imgHaha);

set(gcf, 'Position',  [300, 50, 1000, 500])



%% Exercise 2
% Develop programs

%% Exericse 2a
clear variables
prelength = 3; % Beginning of Time
endlength = 50; % End of Time

n = -1*prelength:endlength; % Time

a0 = 1;
b0 = 0.25445939;

a1 = -0.18902544;
b1 = 0.43220307;

a2 = 0.71974192;
b2 = 0.43220307;

a3 = - 0.15739157;
b3 = 0.25445939;





x1 = [zeros(1,prelength), 1, zeros(1,endlength)]; % Kronecker Delta!
y = [zeros(1,length(n))]; % Allocating Memory!

q = [zeros(1,length(n))]; % Allocating Memory!

% Direct Form II Block Diagram Implementation
for i = prelength+1:prelength+1  +  endlength
   q(1,i) = x1(1,i) - a1 .* q(1,i-1)- a2.*q(1,i-2)- a3.*q(1,i-3); 
   y(1,i) = b0.*q(1,i) + b1.*q(1,i-1)+ b2.*q(1,i-2)+ b3.*q(1,i-3);
end

figure(69)
subplot(4,1,1)
stem(n,x1,'r','linewidth',3)
title('Kronecker Delta, $\delta[n]$','interpreter','latex')
subplot(4,1,2)
stem(n,y,'b','linewidth',3)
title('DFI')
subplot(4,1,3)
stem(n,y,'m','linewidth',3)
title('DFII')
subplot(4,1,4)
stem(n,y,'k','linewidth',3)
title('TDFII')

%% Exercise 3
% Implementing the filter() function

%% Exercise 3a

xLOL = [zeros(1,prelength), 1, zeros(1,endlength)];

B = [b0,b1,b2,b3]; % Our b terms
A = [a0,a1,a2,a3]; % Our a terms lol

yF = filter(B,A,xLOL)

figure(444)
subplot(2,1,2)
stem(n,yF,'k','filled','linewidth',3)
title('Using Teh Filter Function')
subplot(2,1,1)
stem(n,xLOL,'r','linewidth',3)
title('Kroneker Delta, $\delta[n]$','interpreter','latex')

%% Exercise 3c
unitstep = [zeros(1,prelength), 1, ones(1,endlength)];
xcos = cos(0.05*pi.*n).*unitstep;
figure(555)
subplot(2,1,2)
stem(n,xcos,'k','filled','linewidth',3)
title('Cosine')
